# OGRLayer Class Reference

`#include <ogrsf_frmts.h>`

Inherited by OGRGenSQLResultsLayer.

List of all members.

## Public Member Functions
virtual OGRGeometry * | GetSpatialFilter ()
| This method returns the current spatial filter for this layer.
virtual void | SetSpatialFilter (OGRGeometry *)
| Set a new spatial filter.
virtual void | SetSpatialFilterRect (double dfMinX, double dfMinY, double dfMaxX, double dfMaxY)
| Set a new rectangular spatial filter.
virtual OGRErr | SetAttributeFilter (const char *)
| Set a new attribute query.
virtual void | ResetReading ()=0
| Reset feature reading to start on the first feature.
virtual OGRFeature * | GetNextFeature ()=0
| Fetch the next available feature from this layer.
virtual OGRErr | SetNextByIndex (long nIndex)
| Move read cursor to the nIndex'th feature in the current resultset.
virtual OGRFeature * | GetFeature (long nFID)
| Fetch a feature by its identifier.
virtual OGRErr | SetFeature (OGRFeature *poFeature)
| Rewrite an existing feature.
virtual OGRErr | CreateFeature (OGRFeature *poFeature)
| Create and write a new feature within a layer.
virtual OGRErr | DeleteFeature (long nFID)
| Delete feature from layer.
virtual OGRFeatureDefn * | GetLayerDefn ()=0
| Fetch the schema information for this layer.
virtual OGRSpatialReference * | GetSpatialRef ()
| Fetch the spatial reference system for this layer.
virtual int | GetFeatureCount (int bForce=TRUE)
| Fetch the feature count in this layer.
virtual OGRErr | GetExtent (OGREnvelope *psExtent, int bForce=TRUE)
| Fetch the extent of this layer.
virtual int | TestCapability (const char *)=0
| Test if this layer supported the named capability.
virtual const char * | GetInfo (const char *)
| Fetch metadata from layer.
virtual OGRErr | CreateField (OGRFieldDefn *poField, int bApproxOK=TRUE)
| Create a new field on a layer.
virtual OGRErr | SyncToDisk ()
| Flush pending changes to disk.
OGRStyleTable * | GetStyleTable ()
| Returns layer style table.
void | SetStyleTableDirectly (OGRStyleTable *poStyleTable)
| Set layer style table.
void | SetStyleTable (OGRStyleTable *poStyleTable)
| Set layer style table.
virtual const char * | GetFIDColumn ()
| This method returns the name of the underlying database column being used as the FID column, or "" if not supported.
virtual const char * | GetGeometryColumn ()
| This method returns the name of the underlying database column being used as the geometry column, or "" if not supported.
int | Reference ()
| Increment layer reference count.
int | Dereference ()
| Decrement layer reference count.
int | GetRefCount () const
| Fetch reference count.

## Detailed Description

This class represents a layer of simple features, with access methods.

## Member Function Documentation

OGRErr OGRLayer::CreateFeature | ( | OGRFeature * | poFeature | ) | `[virtual]`

Create and write a new feature within a layer.

The passed feature is written to the layer as a new feature, rather than overwriting an existing one. If the feature has a feature id other than OGRNullFID, then the native implementation may use that as the feature id of the new feature, but not necessarily. Upon successful return the passed feature will have been updated with the new feature id.

This method is the same as the C function OGR_L_CreateFeature().

Parameters:

  | poFeature | the feature to write to disk.

Returns:
  OGRERR_NONE on success.

Referenced by OGRDataSource::CopyLayer().

OGRErr OGRLayer::CreateField | ( | OGRFieldDefn * | poField,
|  | int | bApproxOK = `TRUE` |
| ) |  |  | `[virtual]`

Create a new field on a layer.

You must use this to create new fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the new field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This function is the same as the C function OGR_L_CreateField().

Parameters:

  | poField | field definition to write to disk.
  | bApproxOK | If TRUE, the field may be created in a slightly different form depending on the limitations of the format driver.

Returns:
  OGRERR_NONE on success.

Referenced by OGRDataSource::CopyLayer().

OGRErr OGRLayer::DeleteFeature | ( | long | nFID | ) | `[virtual]`

Delete feature from layer.

The feature with the indicated feature id is deleted from the layer if supported by the driver. Most drivers do not support feature deletion, and will return OGRERR_UNSUPPORTED_OPERATION. The TestCapability() layer method may be called with OLCDeleteFeature to check if the driver supports feature deletion.

This method is the same as the C function OGR_L_DeleteFeature().

Parameters:

  | nFID | the feature id to be deleted from the layer

Returns:
  OGRERR_NONE on success.

int OGRLayer::Dereference | ( |  | ) |

Decrement layer reference count.

This method is the same as the C function OGR_L_Dereference().

Returns:
  the reference count after decrementing.

OGRErr OGRLayer::GetExtent | ( | OGREnvelope * | psExtent,
|  | int | bForce = `TRUE` |
| ) |  |  | `[virtual]`

Fetch the extent of this layer.

Returns the extent (MBR) of the data in the layer. If bForce is FALSE, and it would be expensive to establish the extent then OGRERR_FAILURE will be returned indicating that the extent isn't know. If bForce is TRUE then some implementations will actually scan the entire layer once to compute the MBR of all the features in the layer.

Depending on the drivers, the returned extent may or may not take the spatial filter into account. So it is safer to call GetExtent() without setting a spatial filter.

Layers without any geometry may return OGRERR_FAILURE just indicating that no meaningful extents could be collected.

This method is the same as the C function OGR_L_GetExtent().

Parameters:

  | psExtent | the structure in which the extent value will be returned.
  | bForce | Flag indicating whether the extent should be computed even if it is expensive.

Returns:
  OGRERR_NONE on success, OGRERR_FAILURE if extent not known.

References OGRGeometry::getEnvelope(), OGRFeature::GetGeometryRef(), GetLayerDefn(), GetNextFeature(), OGREnvelope::MaxX, OGREnvelope::MaxY, OGREnvelope::MinX, OGREnvelope::MinY, ResetReading(), and wkbNone.

OGRFeature * OGRLayer::GetFeature | ( | long | nFID | ) | `[virtual]`

Fetch a feature by its identifier.

This function will attempt to read the identified feature. The nFID value cannot be OGRNullFID. Success or failure of this operation is unaffected by the spatial or attribute filters.

If this method returns a non-NULL feature, it is guaranteed that its feature id (OGRFeature::GetFID()) will be the same as nFID.

Use OGRLayer::TestCapability(OLCRandomRead) to establish if this layer supports efficient random access reading via GetFeature(); however, the call should always work if the feature exists as a fallback implementation just scans all the features in the layer looking for the desired feature.

Sequential reads are generally considered interrupted by a GetFeature() call.

The returned feature should be free with OGRFeature::DestroyFeature().

This method is the same as the C function OGR_L_GetFeature().

Parameters:

  | nFID | the feature id of the feature to read.

Returns:
  a feature now owned by the caller, or NULL on failure.

References OGRFeature::GetFID(), GetNextFeature(), and ResetReading().

int OGRLayer::GetFeatureCount | ( | int | bForce = `TRUE` | ) | `[virtual]`

Fetch the feature count in this layer.

Returns the number of features in the layer. For dynamic databases the count may not be exact. If bForce is FALSE, and it would be expensive to establish the feature count a value of -1 may be returned indicating that the count isn't know. If bForce is TRUE some implementations will actually scan the entire layer once to count objects.

The returned count takes the spatial filter into account.

This method is the same as the C function OGR_L_GetFeatureCount().

Parameters:

  | bForce | Flag indicating whether the count should be computed even if it is expensive.

Returns:
  feature count, -1 if count not known.

References GetNextFeature(), and ResetReading().

const char * OGRLayer::GetFIDColumn | ( |  | ) | `[virtual]`

This method returns the name of the underlying database column being used as the FID column, or "" if not supported.

This method is the same as the C function OGR_L_GetFIDColumn().

Returns:
  fid column name.

const char * OGRLayer::GetGeometryColumn | ( |  | ) | `[virtual]`

This method returns the name of the underlying database column being used as the geometry column, or "" if not supported.

This method is the same as the C function OGR_L_GetGeometryColumn().

Returns:
  geometry column name.

const char * OGRLayer::GetInfo | ( | const char * | pszTag | ) | `[virtual]`

Fetch metadata from layer.

This method can be used to fetch various kinds of metadata or layer specific information encoded as a string. It is anticipated that various tag values will be defined with well known semantics, while other tags will be used for driver/application specific purposes.

This method is deprecated and will be replaced with a more general metadata model in the future. At this time no drivers return information via the GetInfo() call.

Parameters:

  | pszTag | the tag for which information is being requested.

Returns:
  the value of the requested tag, or NULL if that tag does not have a value, or is unknown.

OGRFeatureDefn * OGRLayer::GetLayerDefn | ( |  | ) | `[pure virtual]`

Fetch the schema information for this layer.

The returned OGRFeatureDefn is owned by the OGRLayer, and should not be modified or freed by the application. It encapsulates the attribute schema of the features of the layer.

This method is the same as the C function OGR_L_GetLayerDefn().

Returns:
  feature definition.

Referenced by OGRSFDriver::CopyDataSource(), OGRDataSource::CopyLayer(), OGRDataSource::ExecuteSQL(), GetExtent(), OGRDataSource::GetLayerByName(), and SetAttributeFilter().

OGRFeature * OGRLayer::GetNextFeature | ( |  | ) | `[pure virtual]`

Fetch the next available feature from this layer.

The returned feature becomes the responsiblity of the caller to delete with OGRFeature::DestroyFeature().

Only features matching the current spatial filter (set with SetSpatialFilter()) will be returned.

This method implements sequential access to the features of a layer. The ResetReading() method can be used to start at the beginning again.

This method is the same as the C function OGR_L_GetNextFeature().

Returns:
  a feature, or NULL if no more features are available.

Referenced by OGRDataSource::CopyLayer(), GetExtent(), GetFeature(), GetFeatureCount(), and SetNextByIndex().

int OGRLayer::GetRefCount | ( |  | ) | const

Fetch reference count.

This method is the same as the C function OGR_L_GetRefCount().

Returns:
  the current reference count for the layer object itself.

Referenced by OGRDataSource::GetSummaryRefCount().

OGRGeometry * OGRLayer::GetSpatialFilter | ( |  | ) | `[virtual]`

This method returns the current spatial filter for this layer.

The returned pointer is to an internally owned object, and should not be altered or deleted by the caller.

This method is the same as the C function OGR_L_GetSpatialFilter().

Returns:
  spatial filter geometry.

OGRSpatialReference * OGRLayer::GetSpatialRef | ( |  | ) | `[inline, virtual]`

Fetch the spatial reference system for this layer.

The returned object is owned by the OGRLayer and should not be modified or freed by the application.

This method is the same as the C function OGR_L_GetSpatialRef().

Returns:
  spatial reference, or NULL if there isn't one.

Referenced by OGRDataSource::CopyLayer().

void OGRLayer::GetStyleTable | ( |  | ) | `[inline]`

Returns layer style table.

This method is the same as the C function OGR_L_GetStyleTable().

Returns:
  pointer to a style table which should not be modified or freed by the caller.

int OGRLayer::Reference | ( |  | ) |

Increment layer reference count.

This method is the same as the C function OGR_L_Reference().

Returns:
  the reference count after incrementing.

void OGRLayer::ResetReading | ( |  | ) | `[pure virtual]`

Reset feature reading to start on the first feature.

This affects GetNextFeature().

This method is the same as the C function OGR_L_ResetReading().

Referenced by OGRDataSource::CopyLayer(), GetExtent(), GetFeature(), GetFeatureCount(), SetAttributeFilter(), SetNextByIndex(), and SetSpatialFilter().

OGRErr OGRLayer::SetAttributeFilter | ( | const char * | pszQuery | ) | `[virtual]`

Set a new attribute query.

This method sets the attribute query string to be used when fetching features via the GetNextFeature() method. Only features for which the query evaluates as true will be returned.

The query string should be in the format of an SQL WHERE clause. For instance "population > 1000000 and population < 5000000" where population is an attribute in the layer. The query format is a restricted form of SQL WHERE clause as defined "eq_format=restricted_where" about half way through this document:

http://ogdi.sourceforge.net/prop/6.2.CapabilitiesMetadata.html

Note that installing a query string will generally result in resetting the current reading position (ala ResetReading()).

This method is the same as the C function OGR_L_SetAttributeFilter().

Parameters:

  | pszQuery | query in restricted SQL WHERE format, or NULL to clear the current query.

Returns:
  OGRERR_NONE if successfully installed, or an error code if the query expression is in error, or some other failure occurs.

References GetLayerDefn(), and ResetReading().

OGRErr OGRLayer::SetFeature | ( | OGRFeature * | poFeature | ) | `[virtual]`

Rewrite an existing feature.

This method will write a feature to the layer, based on the feature id within the OGRFeature.

Use OGRLayer::TestCapability(OLCRandomWrite) to establish if this layer supports random access writing via SetFeature().

This method is the same as the C function OGR_L_SetFeature().

Parameters:

  | poFeature | the feature to write.

Returns:
  OGRERR_NONE if the operation works, otherwise an appropriate error code.

OGRErr OGRLayer::SetNextByIndex | ( | long | nIndex | ) | `[virtual]`

Move read cursor to the nIndex'th feature in the current resultset.

This method allows positioning of a layer such that the GetNextFeature() call will read the requested feature, where nIndex is an absolute index into the current result set. So, setting it to 3 would mean the next feature read with GetNextFeature() would have been the 4th feature to have been read if sequential reading took place from the beginning of the layer, including accounting for spatial and attribute filters.

Only in rare circumstances is SetNextByIndex() efficiently implemented. In all other cases the default implementation which calls ResetReading() and then calls GetNextFeature() nIndex times is used. To determine if fast seeking is available on the current layer use the TestCapability() method with a value of OLCFastSetNextByIndex.

This method is the same as the C function OGR_L_SetNextByIndex().

Parameters:

  | nIndex | the index indicating how many steps into the result set to seek.

Returns:
  OGRERR_NONE on success or an error code.

References GetNextFeature(), and ResetReading().

void OGRLayer::SetSpatialFilter | ( | OGRGeometry * | poFilter | ) | `[virtual]`

Set a new spatial filter.

This method set the geometry to be used as a spatial filter when fetching features via the GetNextFeature() method. Only features that geometrically intersect the filter geometry will be returned.

Currently this test is may be inaccurately implemented, but it is guaranteed that all features who's envelope (as returned by OGRGeometry::getEnvelope()) overlaps the envelope of the spatial filter will be returned. This can result in more shapes being returned that should strictly be the case.

This method makes an internal copy of the passed geometry. The passed geometry remains the responsibility of the caller, and may be safely destroyed.

For the time being the passed filter geometry should be in the same SRS as the layer (as returned by OGRLayer::GetSpatialRef()). In the future this may be generalized.

This method is the same as the C function OGR_L_SetSpatialFilter().

Parameters:

  | poFilter | the geometry to use as a filtering region. NULL may be passed indicating that the current spatial filter should be cleared, but no new one instituted.

References ResetReading().

Referenced by SetSpatialFilterRect().

void OGRLayer::SetSpatialFilterRect | ( | double | dfMinX,
|  | double | dfMinY,
|  | double | dfMaxX,
|  | double | dfMaxY |
| ) |  |  | `[virtual]`

Set a new rectangular spatial filter.

This method set rectangle to be used as a spatial filter when fetching features via the GetNextFeature() method. Only features that geometrically intersect the given rectangle will be returned.

The x/y values should be in the same coordinate system as the layer as a whole (as returned by OGRLayer::GetSpatialRef()). Internally this method is normally implemented as creating a 5 vertex closed rectangular polygon and passing it to OGRLayer::SetSpatialFilter(). It exists as a convenience.

The only way to clear a spatial filter set with this method is to call OGRLayer::SetSpatialFilter(NULL).

This method is the same as the C function OGR_L_SetSpatialFilterRect().

Parameters:

  | dfMinX | the minimum X coordinate for the rectangular region.
  | dfMinY | the minimum Y coordinate for the rectangular region.
  | dfMaxX | the maximum X coordinate for the rectangular region.
  | dfMaxY | the maximum Y coordinate for the rectangular region.

References OGRLineString::addPoint(), OGRPolygon::addRing(), and SetSpatialFilter().

void OGRLayer::SetStyleTable | ( | OGRStyleTable * | poStyleTable | ) | `[inline]`

Set layer style table.

This method operate exactly as OGRLayer::SetStyleTableDirectly() except that it does not assume ownership of the passed table.

This method is the same as the C function OGR_L_SetStyleTable().

Parameters:

  | poStyleTable | pointer to style table to set

References OGRStyleTable::Clone().

void OGRLayer::SetStyleTableDirectly | ( | OGRStyleTable * | poStyleTable | ) | `[inline]`

Set layer style table.

This method operate exactly as OGRLayer::SetStyleTable() except that it assumes ownership of the passed table.

This method is the same as the C function OGR_L_SetStyleTableDirectly().

Parameters:

  | poStyleTable | pointer to style table to set

OGRErr OGRLayer::SyncToDisk | ( |  | ) | `[virtual]`

Flush pending changes to disk.

This call is intended to force the layer to flush any pending writes to disk, and leave the disk file in a consistent state. It would not normally have any effect on read-only datasources.

Some layers do not implement this method, and will still return OGRERR_NONE. The default implementation just returns OGRERR_NONE. An error is only returned if an error occurs while attempting to flush to disk.

In any event, you should always close any opened datasource with OGRDataSource::DestroyDataSource() that will ensure all data is correctly flushed.

This method is the same as the C function OGR_L_SyncToDisk().

Returns:
  OGRERR_NONE if no error occurs (even if nothing is done) or an error code.

Referenced by OGRDataSource::SyncToDisk().

int OGRLayer::TestCapability | ( | const char * | pszCap | ) | `[pure virtual]`

Test if this layer supported the named capability.

The capability codes that can be tested are represented as strings, but #defined constants exists to ensure correct spelling. Specific layer types may implement class specific capabilities, but this can't generally be discovered by the caller.

- OLCRandomRead / "RandomRead": TRUE if the GetFeature() method is implemented in an optimized way for this layer, as opposed to the default implementation using ResetReading() and GetNextFeature() to find the requested feature id.

- OLCSequentialWrite / "SequentialWrite": TRUE if the CreateFeature() method works for this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCRandomWrite / "RandomWrite": TRUE if the SetFeature() method is operational on this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCFastSpatialFilter / "FastSpatialFilter": TRUE if this layer implements spatial filtering efficiently. Layers that effectively read all features, and test them with the OGRFeature intersection methods should return FALSE. This can be used as a clue by the application whether it should build and maintain its own spatial index for features in this layer.

- OLCFastFeatureCount / "FastFeatureCount": TRUE if this layer can return a feature count (via GetFeatureCount()) efficiently ... ie. without counting the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastGetExtent / "FastGetExtent": TRUE if this layer can return its data extent (via GetExtent()) efficiently ... ie. without scanning all the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastSetNextByIndex / "FastSetNextByIndex": TRUE if this layer can perform the SetNextByIndex() call efficiently, otherwise FALSE.

- OLCCreateField / "CreateField": TRUE if this layer can create new fields on the current layer using CreateField(), otherwise FALSE.

- OLCDeleteFeature / "DeleteFeature": TRUE if the DeleteFeature() method is supported on this layer, otherwise FALSE.

- OLCStringsAsUTF8 / "StringsAsUTF8": TRUE if values of OFTString fields are assured to be in UTF-8 format. If FALSE the encoding of fields is uncertain, though it might still be UTF-8.

- OLCTransactions / "Transactions": TRUE if the StartTransaction(), CommitTransaction() and RollbackTransaction() methods work in a meaningful way, otherwise FALSE.

This method is the same as the C function OGR_L_TestCapability().

Parameters:

  | pszCap | the name of the capability to test.

Returns:
  TRUE if the layer has the requested capability, or FALSE otherwise. OGRLayers will return FALSE for any unrecognised capabilities.

The documentation for this class was generated from the following files:

- ogrsf_frmts.h
- ogrsf_frmts.dox
- ogrlayer.cpp

Generated for GDAL by 1.5.7.1.